<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Game Call of Duty                           |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

require_once "CProt_Quake3.php";

class CGame_CoD {
  var $m_Prot;
  var $gameName      = "Call of Duty";
  var $gameImagePath = "images/cod/";
  var $gameImage     = 'default';
  var $gameData      = array();
  var $playerData    = array();

  function CGame_CoD($serverIp, $queryPort) {
    $this->m_Prot = new CProt_Quake3($serverIp, $queryPort);
  }

  function PrepareGameData($gameData) {
    $this->gameData = array();

    $gameHeader = array("Host"=>"sv_hostname","IP"=>"hostip", "Game"=>"gamename", "Version"=>"shortversion", "Gametype"=>"g_gametype", "Map"=>"mapname",
                        "Maxclients"=>"sv_maxclients", "Punkbuster"=>"sv_punkbuster","Password"=>"pswrd");

    foreach ($gameHeader as $Key => $attr) {
      if ($gameData[$attr]) {
        $this->gameData[$Key]= $gameData[$attr];
        $this->gameData[$Key]= htmlspecialchars($this->gameData[$Key]);
        $this->gameData[$Key]= preg_replace("/\^[0-9]/","",$this->gameData[$Key]);
      }
    }
    //--- Gamename
    if ($this->gameData['Game'] == 'main') $this->gameData['Game'] = 'Call of Duty';
    //--- Gametype
    switch ($this->gameData['Gametype']) {
      case 'dm' : $this->gameData['Gametype'] = 'Deathmatch';         break;
      case 'tdm': $this->gameData['Gametype'] = 'Team Deathmatch';    break;
      case 'bel': $this->gameData['Gametype'] = 'Behind Enemy Lines'; break;
      case 're' : $this->gameData['Gametype'] = 'Retrievel';          break;
      case 'sd' : $this->gameData['Gametype'] = 'Search and Destroy';
    }
    //--- Map
    $this->gameImage = strtolower(str_replace(' ','_', $this->gameData['Map']));
    if ($gameData['queryport']) $this->gameData['QueryPort'] = $gameData['queryport'];
  }

  function PreparePlayerData($playerData) {
    $this->playerData = array();

    $playerHeader = array("Player"=>"player_", "Team"=>"team_", "Score"=>"score_","Ping"=>"ping_");

    $playerIdx = 0;
    while ($playerData['player_'.$playerIdx]) {
      $player = array();
      foreach ($playerHeader as $Key => $attr) {
        if ($playerData[$attr.$playerIdx] != "") {
          $player[$Key] = $playerData[$attr.$playerIdx];
        }
      }
      $this->playerData[] = $player;
      $playerIdx++;
    }
  }

  function ReadServerData() {
    //--- Read Game and Playerdata
    $error = $this->m_Prot->ReadServerData();
    if (!$error) {
      $gameData   = $this->m_Prot->GetGameData();
      $playerData = $this->m_Prot->GetPlayerData();

      //--- Get Gameinformation from Severdata
      $this->PrepareGameData  ($gameData);

      //--- Get Playerinformation from Serverdata
      $this->PreparePlayerData($playerData);
      return "";
    } else {
      return $error;
    }
  }
}

?>