<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Gamespy3 Protocoll                          |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

class CProt_GameSpy3 {

  var $m_serverIp;
  var $m_queryPort;

  //---------------
  var $m_requestCmd          = array();
  //---------------

  var $m_serverData;

  function CProt_GameSpy2($serverIp, $queryPort) {
    $this->m_serverIp     = $serverIp;
    $this->m_queryPort    = $queryPort;
    $this->m_requestCmd   = "\xFE\xFD\x00\x10\x20\x30\x40\xFF\xFF\xFF\01";
  }

  function ReadServerData() {
    $error = "";
    $this->m_serverData = '';

    $socket = @fsockopen('udp://'. $this->m_serverIp, $this->m_queryPort, $errno, $errstr, 10);
    if ($socket) {
      socket_set_timeout($socket, 2);
      //--- Send request to Server
      fwrite($socket, $this->m_requestCmd);

      //--- Read response
      $this->m_serverData = fread($socket,2048);
      fclose($socket);
    } else {
      $error = "not connected to the server!";
    }
    return $error;
  }

  function GetGameData() {
    $data     = explode("\x00", $this->m_serverData);
    $gameData = array();

    $gameData["hostip"] = $this->m_serverIp;
    $gameData["queryport"] = $this->m_queryPort;

    if (count($data) > 2) {
      if ($data[1] == "GS2") {
        $m = 0;
        $i = 0;
        while ($i < count($data)-1) {
          $i+=2;
          if ($data[$i] !="") {
            $gameData[$data[$i]]= $data[$i+1];
          } else break;
        }
      }
    }
    return $gameData;
  }

  function GetPlayerData() {
    $data        = explode("\x00", $this->m_serverData);
    $playerData  = array();
    $playerHeader= array();
    if (count($data) > 2) {
      if ($data[1] == "GS2") {
        $m = 0;
        $i = 0;
        while ($i < count($data)-1) {
          $i+=2;
          if ($data[$i] == "") break;
        }
        $i++;
        while ($i < count($data)-1) {
          $i++;
          if ($data[$i] == "") break;
          $playerHeader[] = preg_replace("/^[^0-9a-zA-Z](.*)/",'$1',$data[$i]);
        }
        $nField       =0;
        $nPlayer      =0;
        $nPlayerField =0;
        while (($i < count($data)-1) && (count($playerHeader))) {
          $i++;
          if ($data[$i] == "") break;
          $playerData[$playerHeader[$nPlayerField].$nPlayer] = $data[$i];
          $nPlayer      = floor(++$nField / count($playerHeader));
          $nPlayerField = (++$nPlayerField) % count($playerHeader);
        }
      }
    }
    return $playerData;
  }
}

?>