<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Halflife-b Protocoll                        |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

class CProt_HalfLife_b {

  var $m_serverIp;
  var $m_queryPort;

  //---------------
  var $m_requestCmd          = array();
  //---------------

  var $m_serverData          = array();

  function CProt_HalfLife_b($serverIp, $queryPort) {
    $this->m_serverIp        = $serverIp;
    $this->m_queryPort       = $queryPort;

    $this->m_requestCmd["info"]    = "\xFF\xFF\xFF\xFFTSource Engine Query\x00"; // A2S_INFO
    $this->m_requestCmd["rules"]   = "\xFF\xFF\xFF\xFF\x56";                     // A2S_RULES
    $this->m_requestCmd["players"] = "\xFF\xFF\xFF\xFF\x55";                     // A2S_PLAYER
  }

  function ReadServerData() {
    $error = "";
    $this->m_serverData = array();
    $challenge ="";
    $socket = @fsockopen('udp://'. $this->m_serverIp, $this->m_queryPort, $errno, $errstr, 10);
    if ($socket) {
      socket_set_timeout($socket, 2);
      foreach ($this->m_requestCmd as $Key => $reqCmd) {
        //--- challenge request----------
        //--- sollte fr rules und players gemacht werden, bei rules => timeout!
        if ($Key=="players") {
          $reqChallenge = "\xFF\xFF\xFF\xFF\x57";
          fwrite($socket, $reqChallenge);
          $challenge  = substr(fread($socket,2048), 5, 4);
        }
        //--- challenge einhngen
        $reqCmd .= $challenge;
        //--- Send request to Server
        fwrite($socket, $reqCmd);
        //--- Read response
        $part = fread($socket,2048);
        if ($part) $this->m_serverData[$Key] = $part;
      }
      fclose($socket);

    } else {
      $error = "not connected to the server!";
    }
    return $error;
  }

  function GetGameData() {
    $gameData = array();

    if (substr($this->m_serverData["info"],0,5)=="\xFF\xFF\xFF\xFF\x6D") {
      $data     = substr($this->m_serverData["info"], 5);
      $data     = explode("\x00",$data,6);

      $gameData["serverip"] = $data[0];
      $gameData["hostname"] = $data[1];
      $gameData["mapname"]  = $data[2];
      $gameData["gamename"] = $data[4];

      $values = $data[5];
      $gameData["numplayers"] = ord($values[0]);
      $gameData["maxplayers"] = ord($values[1]);
      $gameData["protvers"]   = ord($values[2]);
      $gameData["servertype"] = $values[3];
      $gameData["serveros"]   = $values[4];
      $gameData["password"]   = ord($values[5]);
      $gameData["modded"]     = ord($values[6]);

      if (chr($values[3]) == "d") {
        $gameData["dedicated"] = "1";
      } else {
        $gameData["dedicated"] = "0";
      }
      if ($gameData["serveros"]="l") {$gameData["serveros"] = "Linux";}
      if ($gameData["serveros"]="w") {$gameData["serveros"] = "Windows";}
      $gameData["queryport"] = $this->m_queryPort;
    }
    return $gameData;
  }

  function GetPlayerData() {
    $playerData = array();
    if (substr($this->m_serverData["players"],0,5)=="\xFF\xFF\xFF\xFF\x44") {
      $data = substr($this->m_serverData['players'], 6);
      $noffs = 0;
      $nPl  = 0;
      $nPlCount = ord($this->m_serverData["players"][5]);
      $nlenData = strlen($data);

      while (($nPl < $nPlCount) && ($noffs < $nlenData)) {
        //--- PlayerNr
        $nPlId = ord($data[$noffs++]);

        //--- Playername
        $sPlayer = "";
        do {
          $sPlayer .= $data[$noffs++];
        } while (($data[$noffs] != "\x00") && ($noffs < $nlenData));
        $noffs++;
        //-- Score + time
        $bdata = unpack("Lscore/ftime", substr($data,$noffs,8));

        $min = floor($bdata["time"] / 60);
		$h   = floor($min / 60);
		$sec = floor($bdata["time"] - ($min * 60));
		$min = $min - ($h * 60);
        $bdata["time"] = sprintf("%02s:%02s:%02s", $h, $min, $sec);

        $noffs += 8;

        if ($noffs <=  $nlenData) {
          $playerData["id_".$nPl] = $nPl+1;
          $playerData["player_".$nPl] = $sPlayer;
          $playerData["score_".$nPl] = $bdata["score"];
          $playerData["time_".$nPl] = $bdata["time"];
        }
        $nPl++;
      }
    }
    return $playerData;
  }
}

?>